d50 fwrite SD_Utility

{
PropForth5.5 with SD-card system
Utility for SD-card
     n blk_dump
     Display block-dump(512bytes)
          Display next block(512bytes) by space key 
          Stop by ESC key
       
     file_dump filename     
     Display file-dump(512bytes)
          Display next block(512bytes) by space key 
          Stop by ESC key
          
     delete filename(directory)
     
2013/08/02 17:23:02
}

: SD_Utility ;

\ Display left index of dump-list
\ ( n -- )  n:index addr 
: leftindex d16 u* .word _ecs ;
\ Display byte data
\ ( n -- )  n:index addr
: .byte. C@ .byte space ;
\ Display ASCII arry to right of dump-list
\ ( n -- )  n:address
: ascii C@ dup bl h7E between invert if drop h2E then emit ;
\ Key input
\ ( -- )
: keyIn fkey? and fkey? and or dup ;

\ Display block(512bytes)
\ ( n -- )  n:block number
: blk_dump
dup 0= if drop 1 then                                  \ Set 1 if block number is 0

begin
     dup                                               \ ( number number )
     ." Block Number:" dup . cr
     \ Read 1 Block(512bytes) from SD-card
     sd_blockread  
             
     tbuf sd_cogbuf
     hex
     d32 0 do
          i leftindex
          2dup          
          \ Copy 8Long(32bytes) from Cog memory to tbuf
          4 cog>mem     
          tbuf d16 bounds
          do
               i .byte.
          loop     
          \ Display ASCII
          space 
          tbuf d16 bounds
          do
               i ascii
	    loop
          cr
          \ next Cog memory
          4 +      
     loop 
     decimal    
     cr
     2drop
                               
     \ Check if continue or stop
     \ Stop if ESC key,  Display next block if space key
     ." Push ESC-key if stopping, space key if continue to display" cr
     begin   
          keyIn
          h1B =                         \ ESC key? 
          if 
               drop                     \ Drop key  
               1                        \ Break outer begin-until
               1                        \ Break this begin-until 
          else 
               h20 =                    \ space key? 
               if 
                    1+                  \ Add 1 to block number
                    0                   \ Continue outer begin-until
                    1                   \ Break this begin-until 
               else
                    0                   \ Continue this begin-until
               then                         
          then
     until
until 
drop                                    \ Drop block number
;


\ Display file-block
\ file_dump filename
: file_dump
\ Get blocknumber from filename   
_sd_fsp dup                                                           \ Get cstr                           
if
     sd_find                                                          \ Get block number
     dup
     \ Get header(1 Block) from SD-card to sd_cogbuf(Cog memory)
     sd_blockread
     \ Get number blocks allocated to this file
     sd_cogbuf h2B + COG@      
     dup cr ." Using Block Size:" . cr                       
     0 do
          dup
          ." Block number:" dup decimal . hex cr
          \ Read 1 block
          sd_blockread                     
          tbuf sd_cogbuf
          d32 0 do                                                    
               i leftindex
               2dup          
               \ Copy 8Long(32bytes) from Cog memory to tbuf
               4 cog>mem     
               tbuf d16 bounds
               do
                    i .byte.                    
               loop  
                  
               \ Display ASCII
               space 
               tbuf d16 bounds
               do
                    i ascii
               loop
               cr
               \ next Cog memory
               4 +                
          loop     
          cr
          2drop
          
          \ Check if loop finished
          lasti? 0=
          if
               \ Stop if ESC key,  Display next block if space key
               ." Push ESC-key if stopping, space key if continue to display" cr
               begin               
                    keyIn
                    h1B =                         \ ESC key? 
                    if 
                         drop 
                         \ Break do-loop, Set lasti to current loop counter
                         0 RS@ seti
                         1    
                    else 
                         h20 =                    \ space key? 
                         if 1 else 0 then                         
                    then
               until
               \ Increment block number
               1+
          then
     loop  
     drop        
else
     \ if not filename, " FILE NOT FOUND"
     drop _fnf
then
decimal
;

wvariable source d26 allot         \ string buffer of source filename
\ Delete file(directory)
\ delete filename
: delete
_sd_fsp dup dup                                                  \ Get cstr   ( cstr cstr cstr )
if
     _sd_hash                                                    \ ( cstr hash )
\                                           hex  tbuf d32 dump decimal
     128 0 
     do                                                          \ Search filename's dir-entry in parent directory(128block)
     	dup i + h7F and v_currentdir COG@ 1+ +                 \ ( cstr hash dirblock )     
          sd_lock
		dup sd_blockread
\		                            sd_cogbuf d512 cogdump
		sd_cogbuf h80 bounds                                   \ Search inside 1block    ( cstr hash dirblock ) 
          do                
                                                                 \ ( cstr hash dirblock ) 
               i COG@ h20202000 <>
               if
                    source i 7 cog>mem                           \ Get 7longs from cog                    
\                                   hex source d32 dump decimal                                   
                    source 3 ST@ cstr=                                   \ Compare filename and name of dir-entry
                    if
                         h20202000 i COG!                        \ Erase filename's dir-entry 
\                                     sd_cogbuf d512 cogdump                         
                         dup sd_blockwrite
                         rot drop                                \ ( hash dirblock)
                         0 rot2 leave                            \ ( 0 hash dirblock )
                    then                    
               then                                                                                     
          8 +loop                                                \ next dir-entry
          sd_unlock                                              \ ( 0 hash dirblock )    ( cstr hash dirblock )
          drop                                                   \ ( 0 hash )             ( cstr hash )
          over 0=
          if
               leave                                             \ ( 0 hash )             ( cstr hash )
          then
     loop
     drop
     0<>
     if hFE ERR then            
else
     \ if not filename, " FILE NOT FOUND" 
     2drop _fnf
then             
;

...
